// Generated by zig-wayland

// Copyright © 2022 Simon Ser
// 
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the "Software"),
// to deal in the Software without restriction, including without limitation
// the rights to use, copy, modify, merge, publish, distribute, sublicense,
// and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice (including the next
// paragraph) shall be included in all copies or substantial portions of the
// Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.
// 

// This protocol extension allows clients to create single-pixel buffers.
// 
// Compositors supporting this protocol extension should also support the
// viewporter protocol extension. Clients may use viewporter to scale a
// single-pixel buffer to a desired size.
// 
// Warning! The protocol described in this file is currently in the testing
// phase. Backward compatible changes may be added together with the
// corresponding interface version bump. Backward incompatible changes can
// only be done by creating a new major version of the extension.
// 

const std = @import("std");
const posix = std.posix;
const client = @import("wayland.zig").client;
const common = @import("common.zig");pub const SinglePixelBufferManagerV1 = opaque {
 pub const generated_version = 1;
 pub const getInterface = common.wp.single_pixel_buffer_manager_v1.getInterface;pub fn setQueue(_single_pixel_buffer_manager_v1: *SinglePixelBufferManagerV1, _queue: *client.wl.EventQueue) void {
    const _proxy: *client.wl.Proxy = @ptrCast(_single_pixel_buffer_manager_v1);
    _proxy.setQueue(_queue);
}pub fn destroy(_single_pixel_buffer_manager_v1: *SinglePixelBufferManagerV1) void {const _proxy: *client.wl.Proxy = @ptrCast(_single_pixel_buffer_manager_v1);_proxy.marshal(0, null);_proxy.destroy();}
pub fn createU32RgbaBuffer(_single_pixel_buffer_manager_v1: *SinglePixelBufferManagerV1, _r:u32, _g:u32, _b:u32, _a:u32) !*client.wl.Buffer{const _proxy: *client.wl.Proxy = @ptrCast(_single_pixel_buffer_manager_v1);var _args = [_]common.Argument{.{ .o = null },.{ .u = _r},.{ .u = _g},.{ .u = _b},.{ .u = _a},};
return @ptrCast(try _proxy.marshalConstructor(1, &_args, client.wl.Buffer.getInterface()));}
};
